
/* Example of building a sophisticated Menu         */

/* Once the basic structure is built,               */
/* just fiddle with the numbers till it looks right */
 
/*  */

 x = addlib("apig.library",0,-30,0)

 portname = "ex18_port"
 p = openport(portname)
 
 call set_apig_globals()
 
 scrtitle    = "Hey Buddy, Yea You,  This is Your New Screen  !"
 wintitle    = "This is your title"
 winidcmp    = CLOSEWINDOW+MENUPICK+RAWKEY
 winflags    = WINDOWCLOSE+WINDOWDEPTH+ACTIVATE+GIMMEZEROZERO
 itemflags   = ITEMTEXT+ITEMENABLED
 compitem    = itemflags+HIGHCOMP
 boxitem     = itemflags+HIGHBOX
 checkeditem = itemflags+HIGHCOMP+CHECKIT+MENUTOGGLE+CHECKED
 
 mselitem    = ITEMTEXT+ITEMENABLED+HIGHCOMP+MENUTOGGLE
  
 scr = openscreen(0,0,640,400,4,4,5,LACE+HIRES,CUSTOMSCREEN,scrtitle)

 colors = allocmem(32)  /* block of mem needed for LOADRGB4() */
                                   /* 32 bytes = 2 * 16                  */
                                   
 colorvalues = ('0000'x || '0fa1'x || '004f'x || '0555'x ,
                        || '0099'x || '0fff'x || '04fd'x || '0f00'x,
                        || '0620'x || '0e50'x || '09f1'x || '0eb0'x,
                        || '0f56'x || '092f'x || '0f00'x || '0ccc'x)
                        
 call storage(colors,colorvalues,32)  /* 32 bytes = 2 * 16 */
 x = loadrgb4(scr,colors,16)          /* 16 colors to load */
 image = loadimage("checkedbuttonbitmap",0,0,0,scr)

 /* open window */
 w1  = openwindow(portname,,,640,400,2,4,winidcmp,winflags,wintitle,scr,,,image) 
 w1rptr = getwindowrastport(w1)
 
z = pitext(w1rptr,200,40," wait a sec ... while I build the menu",1,0,JAM2,0)

x = build_menu_0()

z = cleareol(w1rptr,0,40)
 
x = setmenustrip(w1,menu0)

exitme = 0

z = pitext(w1rptr,200,60,"My favorite editor MENU ",1,0,JAM2,0)
z = pitext(w1rptr,200,70,"Pull down the menus and play with'em ",1,0,JAM2,0)
z = pitext(w1rptr,200,80,"Select'em, select multiple items even ...",1,0,JAM2,0)
z = pitext(w1rptr,200,90,"I'll show you what you selected.",1,0,JAM2,0)
z = pitext(w1rptr,200,100,"(checkmarked items, can be un-checked ) ",1,0,JAM2,0)

aboutlayer = 0 
do forever
     x = waitpkt(portname)
  
     do forever 
  
        msg = '0000 0000'x
        msg = getpkt(portname)

        if msg = '0000 0000'x then leave

        if aboutlayer ~= 0 then 
           do
             call deletelayer(aboutlayer)
             aboutlayer = 0 
           end

        class = getarg(msg,0)

      
        if class = CLOSEWINDOW then exitme = 1

        if class = MENUPICK then   /* display all Menu selections */
           do
              mennum = getarg(msg,1)
              zzz = 0
              fg = 0
              do while mennum ~= MENUNULL 
                 zzz = zzz + 1
                 fg = fg + 1
                 if fg > 15 then fg = 1
                 call cleareol(w1rptr,100,120)
                 call cleareol(w1rptr,100,130)
                 call cleareol(w1rptr,100,140)
                 call cleareol(w1rptr,100,150)
                 call cleareol(w1rptr,100,160)
                 if menunum(mennum) = 0 & itemnum(mennum) = 0 & aboutlayer = 0 then
                    do
                       aboutlayer = createupfrontlayer(w1,70,100,500,250,LAYERSMART,0)
                       layerrp = getlayerrastport(aboutlayer)
                       call setrast(layerrp,6)
                       z = pitext(layerrp,40,10,"No, this is not the Editor you think it is.",9,0,JAM1,0)
                       z = pitext(layerrp,40,30,"This is an ARexx Macro, using the APIG.LIBRARY,",9,0,JAM1,0)
                       z = pitext(layerrp,40,40,"pretending to be something it's not.",9,0,JAM1,0)
                       z = pitext(layerrp,40,60,"The Editor you are thinking of is ...",9,0,JAM1,0)
                       z = pitext(layerrp,40,70,"Copyright of CygnusSoft Software",9,0,JAM1,0)
                       z = pitext(layerrp,40,80,"Published by ASDG, Incorporated, Madison WI",9,0,JAM1,0)
                       z = pitext(layerrp,40,90," ... you have to buy it from them",9,0,JAM1,0)
                       z = pitext(layerrp,40,110," (press MENU button)",9,0,JAM1,0)
                    end
                 z = pitext(w1rptr,100,120,("Selection Number" zzz),fg,0,JAM2,0)
                 z = pitext(w1rptr,120,130,("Menu =" menunum(mennum)),fg,0,JAM2,0)
                 z = pitext(w1rptr,120,140,("Item =" itemnum(mennum)),fg,0,JAM2,0)
                 z = pitext(w1rptr,120,150,("SubI =" subnum(mennum)),fg,0,JAM2,0)
                 zitem = itemaddress(menu0,mennum)
                 zitemfill = getvalue(zitem,18,4,'p')
                 z = pitext(w1rptr,120,160,("Text =" getvalue(zitemfill,12,4,'S')),fg,0,JAM2,0)
                 mennum = getvalue(zitem,32,2,'N')

                 /* the above line is the same as these two
                    item = itemaddress(menu0,mennum)   as prescribed by the
                    mennum = getvalue(item,32,2,'N')   Intuition Manual for
                                                       multiple menu selection
                 */

                 wait 2 sec

              end
           end
        x = reply(msg,0)  
     end  
   if exitme = 1 then leave
   
end

/* close and re-open the window, using menustrip already constructed */
if aboutlayer ~= 0 then 
   deletelayer(aboutlayer)
z =closewindow(w1)
if menu0 = '0000 0000'x then 
   say "MENU was NULL"
z = freemenu(menu0)
say "z = " z " ... the number of 'things' owned by menu" 
z = freemem(colors,32) 

z =closescreen(scr)

exit

build_menu_0:
 
 /* set up menu */
 
  /* MENU 0 */


  menu0 = makemenu(0,"Project",0,0,MENUENABLED,0)
    m0text = makeitext(menu0,"About",0,3,0,1,JAM1,0,0)
    m1text = makeitext(menu0,"Clear",0,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"Open new",0,3,0,1,JAM1,0,0)
    m3text = makeitext(menu0,"Open...",0,3,0,1,JAM1,0,0)
    m4text = makeitext(menu0,"Open...",0,3,0,1,JAM1,0,0)
    m5text = makeitext(menu0,"Save block",0,3,0,1,JAM1,0,0)
    m6text = makeitext(menu0,"Save",0,3,0,1,JAM1,0,0)
    m7text = makeitext(menu0,"Save as",0,3,0,1,JAM1,0,0)
    m8text = makeitext(menu0,"Save all changes",0,3,0,1,JAM1,0,0)
    m9text = makeitext(menu0,"Change current directory",0,3,0,1,JAM1,0,0)
    m10text = makeitext(menu0,"Print block...",0,3,0,1,JAM1,0,0)
    m11text = makeitext(menu0,"Print File...",0,3,0,1,JAM1,0,0)
    m12text = makeitext(menu0,"Quit",0,3,0,1,JAM1,0,0)
    m13text = makeitext(menu0,"Save & Quit",0,3,0,1,JAM1,0,0)
    m14text = makeitext(menu0,"Quit & Die",0,3,0,1,JAM1,0,0)

    maxwidth = IntuiTextLength(m9text)
    m0item0  = makeitem(menu0,"",menu0,0,4,maxwidth,13,compitem,0,' ',2,3,JAM1,m0text,0)

    m0item1 = makeitem(menu0,"",menu0,0,24,maxwidth,13,compitem+COMMSEQ,0,'/',0,1,JAM1,m1text,0)
    m0item2 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem+COMMSEQ,0,'?',0,1,JAM1,m2text,0)
    m0item3 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem+COMMSEQ,0,'o',0,1,JAM1,m3text,0)
    m0item4 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem+COMMSEQ,0,'O',0,1,JAM1,m4text,0)
    m0item5 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem+COMMSEQ,0,'n',0,1,JAM1,m5text,0)
    m0item6 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem+COMMSEQ,0,'w',0,1,JAM1,m6text,0)
    m0item7 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem+COMMSEQ,0,'W',0,1,JAM1,m7text,0)
    m0item8 = makeitem(menu0,"",menu0,0,8,maxwidth,13,compitem,0,'A',0,1,JAM1,m8text,0)
    m0item9 = makeitem(menu0,"",menu0,0,24,maxwidth,13,compitem,0,'A',0,1,JAM1,m9text,0)
    m0item10 = makeitem(menu0,"",menu0,0,24,maxwidth,13,compitem+COMMSEQ,0,'p',0,1,JAM1,m10text,0)
    m0item11 = makeitem(menu0,"",menu0,0,4,maxwidth,13,compitem+COMMSEQ,0,'P',0,1,JAM1,m11text,0)
    m0item12 = makeitem(menu0,"",menu0,0,4,maxwidth,13,compitem+COMMSEQ,q,'q',0,1,JAM1,m12text,0)
    m0item13 = makeitem(menu0,"",menu0,0,4,maxwidth,13,compitem+COMMSEQ,0,'Q',0,1,JAM1,m13text,0)
    m0item14 = makeitem(menu0,"",menu0,0,4,maxwidth,13,compitem,0,'A',0,1,JAM1,m14text,0)
  

  /* MENU 1 */
  menu1 = makemenu(menu0,"   Environment",0,40,MENUENABLED,menu0)
  m1text = makeitext(menu0,"Screen height",0,3,0,1,JAM1,0,0)
  m1item1  = makeitem(menu0,"",menu1,0,4,196,13,boxitem,0,' ',0,1,JAM1,m1text,0)
  
    m1text = makeitext(menu0,"400 pixels",32,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"408 pixels",32,3,0,1,JAM1,0,0)
    m3text = makeitext(menu0,"424 pixels",32,3,0,1,JAM1,0,0)
    m4text = makeitext(menu0,"440 pixels",32,3,0,1,JAM1,0,0)
    m5text = makeitext(menu0,"456 pixels",32,3,0,1,JAM1,0,0)
    m6text = makeitext(menu0,"472 pixels",32,3,0,1,JAM1,0,0)
    m7text = makeitext(menu0,"470 (custom)",32,3,0,1,JAM1,0,0)
    m8text = makeitext(menu0,"Interlace?",24,3,0,1,JAM1,0,0)

    maxwidth = intuitextlength(m7text)+CHECKWIDTH+44
    m1i1s1 = makesubitem(menu0,"",m1item1,98,0,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
    m1i1s2 = makesubitem(menu0,"",m1item1,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m2text,0)
    m1i1s3 = makesubitem(menu0,"",m1item1,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m3text,0)
    m1i1s4 = makesubitem(menu0,"",m1item1,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m4text,0)
    m1i1s5 = makesubitem(menu0,"",m1item1,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m5text,0)
    m1i1s6 = makesubitem(menu0,"",m1item1,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m6text,0)
    m1i1s7 = makesubitem(menu0,"",m1item1,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m7text,0)
    call makesubitem(menu0,"",m1item1,98,-13,maxwidth,32,HIGHNONE+ITEMTEXT,0,' ',1,1,JAM2,0,0)
    m1i1s8 = makesubitem(menu0,"",m1item1,98,-32,maxwidth,13,checkeditem+COMMSEQ,0,'`',0,1,JAM1,m8text,0)

  m1text = makeitext(menu0,"Screen width",0,3,0,1,JAM1,0,0)
  m1item2  = makeitem(menu0,"",menu1,0,4,196,13,boxitem,0,'?',0,1,JAM1,m1text,0)
    m1text = makeitext(menu0,"640 pixels",32,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"656 pixels",32,3,0,1,JAM1,0,0)
    m3text = makeitext(menu0,"672 pixels",32,3,0,1,JAM1,0,0)
    m4text = makeitext(menu0,"688 pixels",32,3,0,1,JAM1,0,0)
    m5text = makeitext(menu0,"704 pixels",32,3,0,1,JAM1,0,0)
    m6text = makeitext(menu0,"800 (custom)",32,3,0,1,JAM1,0,0)

    maxwidth = intuitextlength(m6text)+CHECKWIDTH+44
    m1i2s1 = makesubitem(menu0,"",m1item2,98,0,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
    m1i2s2 = makesubitem(menu0,"",m1item2,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m2text,0)
    m1i2s3 = makesubitem(menu0,"",m1item2,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m3text,0)
    m1i2s4 = makesubitem(menu0,"",m1item2,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m4text,0)
    m1i2s5 = makesubitem(menu0,"",m1item2,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m5text,0)
    m1i2s6 = makesubitem(menu0,"",m1item2,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m6text,0)

  m1text = makeitext(menu0,"Force custom screen?",CHECKWIDTH,3,0,1,JAM1,0,0)
  mw = intuitextlength(m1text)+CHECKWIDTH
  m1item3  = makeitem(menu0, "",menu1,0,4,mw,13,checkeditem,0,' ',0,1,JAM1,m1text,0)

  m1text = makeitext(menu0,"Macro definitions",0,3,0,1,JAM1,0,0)
  m1item4  = makeitem(menu0,"",menu1,0,4,196,13,boxitem,0,' ',0,1,JAM1,m1text,0)
    m1text = makeitext(menu0,"Begin/end definition",0,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"Clear",0,3,0,1,JAM1,0,0)
    m3text = makeitext(menu0,"Load definitions...",0,3,0,1,JAM1,0,0)
    m4text = makeitext(menu0,"Save definitions...",0,3,0,1,JAM1,0,0)

    maxwidth = 12+intuitextlength(m1text)+COMMWIDTH
    m1i4s1 = makesubitem(menu0,"",m1item4,98,0,maxwidth,13,compitem+COMMSEQ,0,'m',0,1,JAM1,m1text,0)
    m1i4s2 = makesubitem(menu0,"",m1item4,98,-13,maxwidth,13,compitem,0,' ',0,1,JAM1,m2text,0)
    m1i4s3 = makesubitem(menu0,"",m1item4,98,-13,maxwidth,13,compitem+COMMSEQ,0,';',0,1,JAM1,m3text,0)
    m1i4s4 = makesubitem(menu0,"",m1item4,98,-13,maxwidth,13,compitem+COMMSEQ,0,"'",0,1,JAM1,m4text,0)

  m1text = makeitext(menu0,"Priority",0,3,0,1,JAM1,0,0)
  m1item5  = makeitem(menu0,"",menu1,0,4,196,13,boxitem,0,' ',0,1,JAM1,m1text,0)
    m1text = makeitext(menu0,"Inherit",32,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"Priority  1?",32,3,0,1,JAM1,0,0)
    m3text = makeitext(menu0,"Set Priority",32,3,0,1,JAM1,0,0)
    maxwidth = 12+intuitextlength(m3text)+COMMWIDTH
    m1i5s1 = makesubitem(menu0,"",m1item5,98,0,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
    m1i5s2 = makesubitem(menu0,"",m1item5,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m2text,0)
    m1i5s3 = makesubitem(menu0,"",m1item5,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m3text,0)

  m1text = makeitext(menu0,"Autosave",0,3,0,1,JAM1,0,0)
  m1item6  = makeitem(menu0,"",menu1,0,4,196,13,boxpitem,0,' ',0,1,JAM1,m1text,0)
    m1text = makeitext(menu0,"Every 35 min ?",32,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"Set Timer",32,3,0,1,JAM1,0,0)
    maxwidth = 12+intuitextlength(m1text)+COMMWIDTH
    m1i2s1 = makesubitem(menu0,"",m1item6,98,0,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
    m1i2s2 = makesubitem(menu0,"",m1item6,98,-13,maxwidth,13,checkeditem,0,' ',0,1,JAM1,m2text,0)

  m1text = makeitext(menu0,"Set icon tool name",0,3,0,1,JAM1,0,0)
  m1item7  = makeitem(menu0,"",menu1,0,4,196,13,compitem,0,' ',0,1,JAM1,m1text,0)

  m1text = makeitext(menu0,"Change colors",0,3,0,1,JAM1,0,0)
  m1item8  = makeitem(menu0, "",menu1,0,4,196,13,compitem,0,'$',0,1,JAM1,m1text,0)

  m1text = makeitext(menu0,"Do safe saves?",32,3,0,1,JAM1,0,0)
  m1item9  = makeitem(menu0,"",menu1,0,4,196,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
  m1text = makeitext(menu0,"Icon Creation?",32,3,0,1,JAM1,0,0)
  m1item10 = makeitem(menu0,"",menu1,0,4,196,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
  m1text = makeitext(menu0,"Hot-Start enabled",32,3,0,1,JAM1,0,0)
  m1item11 = makeitem(menu0,"",menu1,0,4,196,13,checkeditem,0,' ',0,1,JAM1,m1text,0)
  m1text = makeitext(menu0,"Auto-expand views?",32,3,0,1,JAM1,0,0)
  m1item12 = makeitem(menu0,"",menu1,0,4,196,13,checkeditem,q,'[',0,1,JAM1,m1text,0)
  m1text = makeitext(menu0,"keypad = movement?",32,3,0,1,JAM1,0,0)
  m1item13 = makeitem(menu0,"",menu1,0,4,196,13,checkeditem,0,'8',0,1,JAM1,m1text,0)
  m1text = makeitext(menu0,"Load environment",0,3,0,1,JAM1,0,0)
  m1item14 = makeitem(menu0, "",menu1,0,4,196,13,boxitem,0,' ',0,1,JAM1,m1text,0)
    m1text = makeitext(menu0,"Default",0,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"Specify...",0,3,0,1,JAM1,0,0)
    maxwidth = intuitextlength(m2text)+COMMWIDTH
    call makesubitem(menu0,"",m1item14,98,0,maxwidth,13,compitem+COMMSEQ,0,'e',0,1,JAM1,m1text,0)
    call makesubitem(menu0,"",m1item14,98,-13,maxwidth,13,compitem,0,' ',0,1,JAM1,m2text,0)
  m1text = makeitext(menu0,"Save environment...",0,3,0,1,JAM1,0,0)
  m1item15 = makeitem(menu0, "",menu1,0,4,196,13,compitem+COMMSEQ,0,'E',0,1,JAM1,m1text,0)



  /* MENU 2 */

  /* in the statement below a NULL string is used for the menu text.    */
  /* The -112, positions the select box 112 pixels from the LEFT edge   */
  /* of the screen.  36, is the width of the select box, even though no */
  /* text is specified.  Thus this menu will overlap the 'Environment'  */
  /* text from MENU 1 above.                                            */

  menu2 = makemenu(menu0,"",-112,36,MENUENABLED,menu0)

    m0text = makeitext(menu0,"File settings      ",0,3,0,1,JAM1,0,0)
    m1text = makeitext(menu0,"Tab size",0,3,0,1,JAM1,0,0)
    mw = intuitextlength(m0text)+COMMWIDTH

  m2item0  = makeitem(menu0,"",menu2,0,0,mw,13,HIGHNONE+ITEMTEXT,0,' ',0,1,JAM1,m0text,0)

  m2item1  = makeitem(menu0,"",menu2,0,-13,mw,13,boxitem,0,' ',0,1,JAM1,m1text,0)
    m0text = makeitext(menu0," 1",CHECKWIDTH,3,0,1,JAM1,0,0)
    m1text = makeitext(menu0," 2",CHECKWIDTH,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0," 3",CHECKWIDTH,3,0,1,JAM1,0,0)
    m3text = makeitext(menu0," 4",CHECKWIDTH,3,0,1,JAM1,0,0)
    m4text = makeitext(menu0," 5",CHECKWIDTH,3,0,1,JAM1,0,0)
    m5text = makeitext(menu0," 6",CHECKWIDTH,3,0,1,JAM1,0,0)
    m6text = makeitext(menu0," 7",CHECKWIDTH,3,0,1,JAM1,0,0)
    m7text = makeitext(menu0," 8",CHECKWIDTH,3,0,1,JAM1,0,0)
    m8text = makeitext(menu0," 9",CHECKWIDTH,3,0,1,JAM1,0,0)
    m9text = makeitext(menu0,"10",CHECKWIDTH,3,0,1,JAM1,0,0)

    maxwidth = intuitextlength(m9text)+CHECKWIDTH+4
    call makesubitem(menu0,"",m2item1,98,0,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m0text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m1text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m2text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m3text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m4text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m5text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m6text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m7text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m8text,0)
    call makesubitem(menu0,"",m2item1,98,-16,maxwidth,16,checkeditem,0,' ',0,1,JAM1,m9text,0)


  m2text = makeitext(menu0,"Customize tabs    ",0,3,0,1,JAM1,0,0)
  m3text = makeitext(menu0,"Set right border  ",0,3,0,1,JAM1,0,0)
  m4text = makeitext(menu0,"Set scroll jump",0,3,0,1,JAM1,0,0)
  m2item2  = makeitem(menu0,"",menu2,0,-13,mw,13,compitem+COMMSEQ,0,'t',0,1,JAM1,m2text,0)
  m2item3  = makeitem(menu0,"",menu2,0,20,mw,13,compitem+COMMSEQ,0,'^',0,1,JAM1,m3text,0)
  m2item4  = makeitem(menu0,"",menu2,0,4,mw,13,boxitem,0,' ',0,1,JAM1,m4text,0)
    m1text = makeitext(menu0,"1 pixel ",28,3,0,1,JAM1,0,0)
    m2text = makeitext(menu0,"2 pixels",28,3,0,1,JAM1,0,0)
    call makeitext(menu0,"Oops! How did this happen",0,40,4,5,JAM2,0,m2text)
    m3text = makeitext(menu0,"4 pixels",28,3,0,1,JAM1,0,0)
    m4text = makeitext(menu0,"8 pixels",28,3,0,1,JAM1,0,0)
    call makesubitem(menu0,"",m2item4,98,0,100,15,checkeditem,0,' ',0,1,JAM1,m1text,0)
    call makesubitem(menu0,"",m2item4,98,-15,98,15,checkeditem,0,' ',0,1,JAM1,m2text,0)
    call makesubitem(menu0,"",m2item4,198,65536,98,15,checkeditem,0,' ',0,1,JAM1,m3text,0)
    call makesubitem(menu0,"",m2item4,198,100,98,15,checkeditem,0,' ',0,1,JAM1,m4text,0)
    m5text = makeitext(menu0,"Layout?",CHECKWIDTH,3,0,1,JAM1,0,0)
    m6text = makeitext(menu0,"Word wrap?",CHECKWIDTH,3,0,1,JAM1,0,0)
    m7text = makeitext(menu0,"Insert mode?",CHECKWIDTH,3,0,1,JAM1,0,0)
    m8text = makeitext(menu0,"Tabs = spaces? ",CHECKWIDTH,3,0,1,JAM1,0,0)
    m2item5  = makeitem(menu0,"",menu2,0,20,mw,13,checkeditem,0,'5',0,1,JAM1,m5text,0)
    m2item6  = makeitem(menu0,"",menu2,0,4,mw,13,checkeditem,0,'6',0,1,JAM1,m6text,0)
    m2item7  = makeitem(menu0,"",menu2,0,4,mw,13,checkeditem,0,'7',0,1,JAM1,m7text,0)
    m2item8  = makeitem(menu0,"",menu2,0,4,mw,13,checkeditem,0,'0',0,1,JAM1,m8text,0)


  /* MENU 3 */

  /* this menu does the same as MENU 2, overlapping 'Environment' at  */
  /* 144 pixels from the LEFT edge of the screen.                     */

  menu3 = makemenu(menu0,"",-144,48,MENUENABLED,menu0)

     m5text = makeitext(menu0,"Status line",0,3,0,1,JAM1,0,0)
     m6text = makeitext(menu0,"White spaces",0,3,0,1,JAM1,0,0)
     m7text = makeitext(menu0,"Scroll bar",0,3,0,1,JAM1,0,0)
     m8text = makeitext(menu0,"Set scroll borders...",0,3,0,1,JAM1,0,0)
     maxwidth = intuitextlength(m8text)+COMMWIDTH+CHECKWIDTH
     m3item4  = makeitem(menu0,"View settings",menu3,0,0,196,13,ITEMTEXT,0,'5',0,1,JAM1,0,0)

     m3item5  = makeitem(menu0,"",menu3,0,0,maxwidth,13,boxitem,0,'5',0,1,JAM1,m5text,0)
       m1text = makeitext(menu0,"On/Off",CHECKWIDTH,3,0,1,JAM1,0,0)
       m2text = makeitext(menu0,"Changes",CHECKWIDTH,3,0,1,JAM1,0,0)
       m3text = makeitext(menu0,"Pages",CHECKWIDTH,3,0,1,JAM1,0,0)
       mw = intuitextlength(m2text)+CHECKWIDTH+COMMWIDTH+12
       call makesubitem(menu0,"",m3item5,98,0,mw,15,checkeditem+COMMSEQ,0,'9 ',0,1,JAM1,m1text,0)
       call makesubitem(menu0,"",m3item5,98,-15,mw,15,checkeditem,0,' ',0,1,JAM1,m2text,0)
       call makesubitem(menu0,"",m3item5,98,-15,mw,15,checkeditem,0,' ',0,1,JAM1,m3text,0)

     m3item6  = makeitem(menu0,"",menu3,0,4,maxwidth,13,boxitem,0,'6',0,1,JAM1,m6text,0)
       m1text = makeitext(menu0,"Tabs visible?",CHECKWIDTH,3,0,1,JAM1,0,0)
       m2text = makeitext(menu0,"Spaces visible?",CHECKWIDTH,3,0,1,JAM1,0,0)
       m3text = makeitext(menu0,"Eols visible?",CHECKWIDTH,3,0,1,JAM1,0,0)
       m4text = makeitext(menu0,"Esc codes visible?",CHECKWIDTH,3,0,1,JAM1,0,0)
       mw = intuitextlength(m4text)+CHECKWIDTH+COMMWIDTH+12
       call makesubitem(menu0,"",m3item6,98,0,mw,15,checkeditem+COMMSEQ,0,'&',0,1,JAM1,m1text,0)
       call makesubitem(menu0,"",m3item6,98,-15,mw,15,checkeditem+COMMSEQ,0,'*',0,1,JAM1,m2text,0)
       call makesubitem(menu0,"",m3item6,98,-15,mw,15,checkeditem+COMMSEQ,0,'(',0,1,JAM1,m3text,0)
       call makesubitem(menu0,"",m3item6,98,-15,mw,15,checkeditem+COMMSEQ,0,')',0,1,JAM1,m4text,0)

     m3item7  = makeitem(menu0,"",menu3,0,22,maxwidth,13,boxitem,0,'7',0,1,JAM1,m7text,0)
       m1text = makeitext(menu0,"Scroll bar on left",CHECKWIDTH,3,0,1,JAM1,0,0)
       m2text = makeitext(menu0,"Scroll bar on right",CHECKWIDTH,3,0,1,JAM1,0,0)
       m3text = makeitext(menu0,"No scroll bar",CHECKWIDTH,3,0,1,JAM1,0,0)
       mw = intuitextlength(m2text)+CHECKWIDTH
       call makesubitem(menu0,"",m3item7,98,0,mw,15,checkeditem,0,' ',0,1,JAM1,m1text,0)
       call makesubitem(menu0,"",m3item7,98,-15,mw,15,checkeditem,0,' ',0,1,JAM1,m2text,0)
       call makesubitem(menu0,"",m3item7,98,-15,mw,15,checkeditem,0,' ',0,1,JAM1,m3text,0)

     m3item8  = makeitem(menu0,"",menu3,0,4,maxwidth,13,compitem+COMMSEQ,0,'z',0,1,JAM1,m8text,0)


  /* MENU 4 */
  menu4 = makemenu(menu0,"Special",45,TextLength(w1rptr,"Special",-1)+28,MENUENABLED,menu0)
  m0text = makeitext(menu0,"View operations",0,3,0,1,JAM1,0,0)
  m4item0  = makeitem(menu0,"",menu4,0,0,196,13,boxitem,0,'5',0,1,JAM1,m0text,0)
     m0text = makeitext(menu0,"Previous view",0,3,0,1,JAM1,0,0)
     m1text = makeitext(menu0,"Next view",0,3,0,1,JAM1,0,0)
     m2text = makeitext(menu0,"Split view",0,3,0,1,JAM1,0,0)
     m3text = makeitext(menu0,"Expand vide",0,3,0,1,JAM1,0,0)
     m4text = makeitext(menu0,"Grow view",0,3,0,1,JAM1,0,0)
     m5text = makeitext(menu0,"Shrink view",0,3,0,1,JAM1,0,0)
     maxwidth = 12+intuitextlength(m0text)+COMMWIDTH
     call makesubitem(menu0,"",m4item0,98,0,maxwidth,15,compitem+COMMSEQ,0,',',0,1,JAM1,m0text,0)
     call makesubitem(menu0,"",m4item0,98,-15,maxwidth,15,compitem+COMMSEQ,0,'.',0,1,JAM1,m1text,0)
     call makesubitem(menu0,"",m4item0,98,-15,maxwidth,15,compitem+COMMSEQ,0,'d',0,1,JAM1,m2text,0)
     call makesubitem(menu0,"",m4item0,98,-15,maxwidth,15,compitem+COMMSEQ,0,']',0,1,JAM1,m3text,0)
     call makesubitem(menu0,"",m4item0,98,-15,maxwidth,15,compitem,0,' ',0,1,JAM1,m4text,0)
     call makesubitem(menu0,"",m4item0,98,-15,maxwidth,15,compitem,0,' ',0,1,JAM1,m5text,0)
 

  m1text = makeitext(menu0,"Format",0,3,0,1,JAM1,0,0)
  m4item1  = makeitem(menu0,"",menu4,0,0,150,13,boxitem,0,' ',0,1,JAM1,m1text,0)
     m0text = makeitext(menu0,"With fill      ",0,3,0,1,JAM1,0,0)
     m1text = makeitext(menu0,"Without fill   ",0,3,0,1,JAM1,0,0)
     m2text = makeitext(menu0,"Oops !!",0,3,0,1,JAM1,0,0)
     maxwidth = intuitextlength(m1text)+COMMWIDTH
     call makesubitem(menu0,"",m4item1,-maxwidth,0,maxwidth,15,compitem+COMMSEQ,0,'f',0,1,JAM1,m0text,0)
     call makesubitem(menu0,"",m4item1,-maxwidth,-15,maxwidth,15,compitem+COMMSEQ,0,'F',0,1,JAM1,m1text,0)
     call makesubitem(menu0,"",m4item1,-maxwidth,35,maxwidth,15,compitem,0,' ',0,1,JAM1,m2text,0)


  m2text = makeitext(menu0,"DOS/Rexx interface",0,3,0,1,JAM1,0,0)
  m4item2  = makeitem(menu0,"",menu4,0,0,196,13,boxitem,0,' ',0,1,JAM1,m2text,0)
     m0text = makeitext(menu0,"Send DOS/Rexx command",0,3,0,1,JAM1,0,0)
     m1text = makeitext(menu0,"Install DOS/Rexx command",0,3,0,1,JAM1,0,0)
     m2text = makeitext(menu0,"Load DOS/Rexx command",0,3,0,1,JAM1,0,0)
     m3text = makeitext(menu0,"Save DOS/Rexx command",0,3,0,1,JAM1,0,0)
     m4text = makeitext(menu0,"command #1 - F1",0,3,0,1,JAM1,0,0)
     m5text = makeitext(menu0,"command #2 - F2",0,3,0,1,JAM1,0,0)
     m6text = makeitext(menu0,"command #3 - F3",0,3,0,1,JAM1,0,0)
     m7text = makeitext(menu0,"command #4 - F4",0,3,0,1,JAM1,0,0)
     m8text = makeitext(menu0,"command #5 - F5",0,3,0,1,JAM1,0,0)
     m9text = makeitext(menu0,"command #6 - F6",0,3,0,1,JAM1,0,0)
     m10text = makeitext(menu0,"command #7 - F7",0,3,0,1,JAM1,0,0)
     m11text = makeitext(menu0,"command #8 - F8",0,3,0,1,JAM1,0,0)
     m12text = makeitext(menu0,"command #9 - F9",0,3,0,1,JAM1,0,0)
     m13text = makeitext(menu0,"command #10 - F10",0,3,0,1,JAM1,0,0)
     maxwidth = 12+intuitextlength(m1text)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m0text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m1text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m2text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m3text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m4text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m5text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m6text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m7text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m8text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m9text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m10text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m11text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m12text,0)
     call makesubitem(menu0,"",m4item2,98,0,maxwidth,15,compitem,0,' ',0,1,JAM1,m13text,0)

     m3text = makeitext(menu0,"Enter ascii",0,3,0,1,JAM1,0,0)
     m4item3  = makeitem(menu0,"",menu4,0,18,196+COMMWIDTH,13,compitem+COMMSEQ,0,'-',0,1,JAM1,m3text,0)

     m4text = makeitext(menu0,"Center cursor",0,3,0,1,JAM1,0,0)
     m4item4  = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'=',0,1,JAM1,m4text,0)

     m5text = makeitext(menu0,"Center line",0,3,0,1,JAM1,0,0)
     m4item5  = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'\',0,1,JAM1,m5text,0)

     m6text = makeitext(menu0,"Repeat key/menu",0,3,0,1,JAM1,0,0)
     m4item6  = makeitem(menu0,"",menu4,0,16,196+COMMWIDTH,13,compitem+COMMSEQ,0,'"',0,1,JAM1,m6text,0)

     m7text = makeitext(menu0,"Find matching bracket",0,3,0,1,JAM1,0,0)
     m4item7  = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'h',0,1,JAM1,m7text,0)

     m8text = makeitext(menu0,"Mark location 1",0,3,0,1,JAM1,0,0)
     m4item8  = makeitem(menu0,"",menu4,0,16,196+COMMWIDTH,13,compitem+COMMSEQ,0,'!',0,1,JAM1,m8text,0)

     m9text = makeitext(menu0,"Mark location 2",0,3,0,1,JAM1,0,0)
     m4item9  = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'@',0,1,JAM1,m9text,0)

     m10text = makeitext(menu0,"Mark location 3",0,3,0,1,JAM1,0,0)
     m4item10 = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'#',0,1,JAM1,m10text,0)

     m11text = makeitext(menu0,"Jump to mark 1",0,3,0,1,JAM1,0,0)
     m4item11 = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'1',0,1,JAM1,m11text,0)

     m12text = makeitext(menu0,"Jump to mark 2",0,3,0,1,JAM1,0,0)
     m4item12 = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'2',0,1,JAM1,m12text,0)

     m13text = makeitext(menu0,"Jump to mark 3",0,3,0,1,JAM1,0,0)
     m4item13 = makeitem(menu0,"",menu4,0,3,196+COMMWIDTH,13,compitem+COMMSEQ,0,'3',0,1,JAM1,m13text,0)


  /* MENU 5 */
  menu5 = makemenu(menu0,"Cut/Paste",10,0,MENUENABLED,menu0)
     m0text  = makeitext(menu0,"Mark block",0,3,0,1,JAM1,0,0)
     m1text  = makeitext(menu0,"Mark columnar block",0,3,0,1,JAM1,0,0)
     m2text  = makeitext(menu0,"Cut block",0,3,0,1,JAM1,0,0)
     m3text  = makeitext(menu0,"Copy block",0,3,0,1,JAM1,0,0)
     m4text  = makeitext(menu0,"Insert block",0,3,0,1,JAM1,0,0)
     m5text  = makeitext(menu0,"Save block to file",0,3,0,1,JAM1,0,0)
     m6text  = makeitext(menu0,"Rot block",0,3,0,1,JAM1,0,0)
     m7text  = makeitext(menu0,"Strip CR block",0,3,0,1,JAM1,0,0)
     m8text  = makeitext(menu0,"Change case block",0,3,0,1,JAM1,0,0)
     m9text  = makeitext(menu0,"Delete word         Alt Del",0,3,0,1,JAM1,0,0)
     m10text = makeitext(menu0,"Undelete word  Ctrl Alt Del",0,3,0,1,JAM1,0,0)
     m11text = makeitext(menu0,"Delete line",0,3,0,1,JAM1,0,0)
     m12text = makeitext(menu0,"Delete to EOL",0,3,0,1,JAM1,0,0)
     m13text = makeitext(menu0,"Undelete line",0,3,0,1,JAM1,0,0)

     maxwidth = intuitextlength(m10text)
     m5item0  = makeitem(menu0,"",menu5,0,0,maxwidth,13,compitem+COMMSEQ,0,'b',0,1,JAM1,m0text,0)
     m5item1  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'v',0,1,JAM1,m1text,0)
     m5item2  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'x',0,1,JAM1,m2text,0)
     m5item3  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'c',0,1,JAM1,m3text,0)
     m5item4  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'i',0,1,JAM1,m4text,0)
     m5item5  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'n',0,1,JAM1,m5text,0)
     m5item6  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem,0,' ',0,1,JAM1,m6text,0)
     m5item7  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem,0,' ',0,1,JAM1,m7text,0)
     m5item8  = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem,0,' ',0,1,JAM1,m8text,0)
     m5item9  = makeitem(menu0,"",menu5,0,16,maxwidth,13,compitem,0,' ',0,1,JAM1,m9text,0)
     m5item10 = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem,0,' ',0,1,JAM1,m10text,0)
     m5item11 = makeitem(menu0,"",menu5,0,16,maxwidth,13,compitem+COMMSEQ,0,'k',0,1,JAM1,m11text,0)
     m5item12 = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'y',0,1,JAM1,m12text,0)
     m5item13 = makeitem(menu0,"",menu5,0,3,maxwidth,13,compitem+COMMSEQ,0,'l',0,1,JAM1,m13text,0)
   

  /* MENU 6 */
  menu6 = makemenu(menu0,"Search/Replace",10,0,MENUENABLED,menu0)
     m0text = makeitext(menu0,"Repeat search backwards",0,3,0,1,JAM1,0,0)
     m1text = makeitext(menu0,"Repeat search fowards",0,3,0,1,JAM1,0,0)
     m2text = makeitext(menu0,"Search for...",0,3,0,1,JAM1,0,0)
     m3text = makeitext(menu0,"Repeat replace",0,3,0,1,JAM1,0,0)
     m4text = makeitext(menu0,"Replace...",0,3,0,1,JAM1,0,0)
     m5text = makeitext(menu0,"Change case letter",0,3,0,1,JAM1,0,0)
     m6text = makeitext(menu0,"Change case word",0,3,0,1,JAM1,0,0)
     m7text = makeitext(menu0,"Upper case word",0,3,0,1,JAM1,0,0)
     m8text = makeitext(menu0,"Lower case word",0,3,0,1,JAM1,0,0)
     maxwidth = intuitextlength(m0text)
     m6item0  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'a',0,1,JAM1,m0text,0)
     m6item1  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'s',0,1,JAM1,m1text,0)
     m6item2  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'S',0,1,JAM1,m2text,0)
     m6item3  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'r',0,1,JAM1,m3text,0)
     m6item4  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'R',0,1,JAM1,m4text,0)
     m6item5  = makeitem(menu0,"",menu6,0,18,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'g',0,1,JAM1,m5text,0)
     m6item6  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'G',0,1,JAM1,m6text,0)
     m6item7  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'u',0,1,JAM1,m7text,0)
     m6item8  = makeitem(menu0,"",menu6,0,3,maxwidth+COMMWIDTH,13,compitem+COMMSEQ,0,'U',0,1,JAM1,m8text,0)


  /* MENU 7 */
  menu7 = makemenu(menu0,"Move",-550,0,MENUENABLED,menu0)
     m0text = makeitext(menu0,"Jump to line...",0,3,0,1,JAM1,0,0)
     m1text = makeitext(menu0,"Jump to auto-mark",0,3,0,1,JAM1,0,0)
     m2text = makeitext(menu0,"   Beg of screen",0,3,0,1,JAM1,0,0)
     m3text = makeitext(menu0,"   End of screen",0,3,0,1,JAM1,0,0)
     m4text = makeitext(menu0,"   Beg of line",0,3,0,1,JAM1,0,0)
     m5text = makeitext(menu0,"   End of line",0,3,0,1,JAM1,0,0)
     m6text = makeitext(menu0,"   Up 12 lines",0,3,0,1,JAM1,0,0)
     m7text = makeitext(menu0,"   Down 12 lines",0,3,0,1,JAM1,0,0)
     m8text = makeitext(menu0,"   Left 12 chars",0,3,0,1,JAM1,0,0)
     m9text = makeitext(menu0,"   Right 12 chars",0,3,0,1,JAM1,0,0)
     m10text = makeitext(menu0,"   Beg of file",0,3,0,1,JAM1,0,0)
     m11text = makeitext(menu0,"   End of file",0,3,0,1,JAM1,0,0)
     m12text = makeitext(menu0,"   Prev word",0,3,0,1,JAM1,0,0)
     m13text = makeitext(menu0,"   Next word",0,3,0,1,JAM1,0,0)
     maxwidth = 12+intuitextlength(m1text)+COMMWIDTH
     ledge = -1 * (maxwidth - 55)
     m7item0  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem+COMMSEQ,0,'j',0,1,JAM1,m0text,0)
     m7item1  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem+COMMSEQ,0,'4',0,1,JAM1,m1text,0)
     m7item2  = makeitem(menu0,"",menu7,ledge,20,maxwidth,13,compitem,0,'5',0,1,JAM1,m2text,0)
     m7item3  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m3text,0)
     m7item4  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m4text,0)
     m7item5  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m5text,0)
     m7item6  = makeitem(menu0,"",menu7,ledge,20,maxwidth,13,compitem,0,'5',0,1,JAM1,m6text,0)
     m7item7  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m7text,0)
     m7item8  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m8text,0)
     m7item9  = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m9text,0)
     m7item10 = makeitem(menu0,"",menu7,ledge,20,maxwidth,13,compitem,0,'5',0,1,JAM1,m10text,0)
     m7item11 = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m11text,0)
     m7item12 = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m12text,0)
     m7item13 = makeitem(menu0,"",menu7,ledge,0,maxwidth,13,compitem,0,'5',0,1,JAM1,m13text,0)




  return 1
